//-----------------------------------------------------------------------------
#ifndef AssignIPDlgH
#define AssignIPDlgH AssignIPDlgH
//-----------------------------------------------------------------------------
#include "wx/wx.h"
#include "wx/dynlib.h"
#include <mvIMPACT_CPP/mvIMPACT_acquire.h>

class wxButton;
class wxComboBox;
class wxTextCtrl;

typedef void* MVTLI_HANDLE;
typedef int (DMR_CALL *TTLOpen)( MVTLI_HANDLE *phTL );
typedef int (DMR_CALL *TTLClose)( MVTLI_HANDLE hTL );
typedef int (DMR_CALL *TTLGetNumInterfaces)( MVTLI_HANDLE hTL, unsigned int* cnt );
typedef int (DMR_CALL *TTLGetInterfaceName)( MVTLI_HANDLE hTL, unsigned int iIndex, char* psName, size_t* iSize );
typedef int (DMR_CALL *TTLIMV_MACFromSerial)( const char* pSerial, char* pBuf, size_t* pBufSize );
typedef int (DMR_CALL *TTLIMV_ForceIP)( const char* pMACAddress, const char* pNewDeviceIPAddress, const char* pStaticSubnetMask, const char* pStaticDefaultGateway, const char* pAdapterIPAddress, unsigned int timeout_ms );

//-----------------------------------------------------------------------------
class AssignIPDlg : public wxDialog
//-----------------------------------------------------------------------------
{
	wxDynamicLibrary& TLILib_;
	wxTextCtrl* pTCDeviceMACAddress_;
	wxTextCtrl* pTCDesiredIPAddress_;
	wxTextCtrl* pTCDesiredSubnetMask_;
	wxTextCtrl* pTCDesiredGateway_;
	wxButton* pBtnBuildMACAddress_;
	wxButton* pBtnExecute_;
	wxComboBox* pCBAdapterList;
	//-----------------------------------------------------------------------------
	enum TWidgetIDs
	//-----------------------------------------------------------------------------
	{
		widBtnExecute = 1,
		widTCMACAddress,
		widDesiredIPAddress,
		widBtnBuildMACAddress,
		widDesiredSubnetMask,
		widDesiredGateway,
		widAdapterList
	};
	TTLOpen pTLOpen_;
	TTLClose pTLClose_;
	TTLGetNumInterfaces pTLGetNumInterfaces_;
	TTLGetInterfaceName pTLGetInterfaceName_;
	TTLIMV_MACFromSerial pTLIMV_MACFromSerial_;
	TTLIMV_ForceIP pTLIMV_ForceIP_;
	MVTLI_HANDLE hTL_;
	void OnBtnExecute( wxCommandEvent& );
	void OnBtnBuildMACAddress( wxCommandEvent& );
public:
	AssignIPDlg( wxWindow* pParent, wxDynamicLibrary& TLILib );
	~AssignIPDlg();
	// any class wishing to process wxWidgets events must use this macro
	DECLARE_EVENT_TABLE()
};

#endif // AssignIPDlgH
